/*
 * Copyright (c) 2009 Albert Kurucz. 
 *
 * This file, StarterCommonPanel.java is part of JTStand.
 *
 * JTStand is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * JTStand is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with GTStand.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.jtstand.swing;

/**
 *
 * @author  albert_kurucz
 */
public class StarterCommonPanel extends AbstractStarterPanel {

    public static final long serialVersionUID = 20081114L;

    /** Creates new form StarterPanel */
    public StarterCommonPanel() {
        initComponents();
        jLabelSerialNumber.setPreferredSize(jLabelSerialNumber.getMinimumSize());
        jLabelPartNumber.setPreferredSize(jLabelSerialNumber.getMinimumSize());
        jLabelPartRev.setPreferredSize(jLabelSerialNumber.getMinimumSize());
        jLabelTestType.setPreferredSize(jLabelSerialNumber.getMinimumSize());
    }

    @Override
    public javax.swing.JButton jButtonStart() {
        return jButtonStart;
    }

    @Override
    public javax.swing.JButton jButtonDebug() {
        return jButtonDebug;
    }

    @Override
    public javax.swing.JButton jButtonCancel() {
        return jButtonCancel;
    }

    @Override
    public javax.swing.JComboBox jComboBoxPartNumber() {
        return jComboBoxPartNumber;
    }

    @Override
    public javax.swing.JComboBox jComboBoxPartRev() {
        return jComboBoxPartRev;
    }

    @Override
    public javax.swing.JComboBox jComboBoxTestType() {
        return jComboBoxTestType;
    }

    @Override
    public javax.swing.JTextField jTextFieldSN() {
        return jTextFieldSN;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jPanel5 = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        jPanel10 = new javax.swing.JPanel();
        jLabelSerialNumber = new javax.swing.JLabel();
        jPanel9 = new javax.swing.JPanel();
        jTextFieldSN = new javax.swing.JTextField();
        jPanel3 = new javax.swing.JPanel();
        jPanel6 = new javax.swing.JPanel();
        jLabelPartNumber = new javax.swing.JLabel();
        jPanel4 = new javax.swing.JPanel();
        jComboBoxPartNumber = new javax.swing.JComboBox();
        jPanel7 = new javax.swing.JPanel();
        jLabelPartRev = new javax.swing.JLabel();
        jPanel8 = new javax.swing.JPanel();
        jComboBoxPartRev = new javax.swing.JComboBox();
        jPanel11 = new javax.swing.JPanel();
        jLabelTestType = new javax.swing.JLabel();
        jPanel12 = new javax.swing.JPanel();
        jComboBoxTestType = new javax.swing.JComboBox();
        jPanel1 = new javax.swing.JPanel();
        jButtonStart = new javax.swing.JButton();
        jButtonDebug = new javax.swing.JButton();
        jButtonCancel = new javax.swing.JButton();

        setBorder(javax.swing.BorderFactory.createEmptyBorder(8, 8, 8, 8));
        setLayout(new java.awt.BorderLayout());

        jPanel5.setLayout(new javax.swing.BoxLayout(jPanel5, javax.swing.BoxLayout.Y_AXIS));

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder("ID"));
        jPanel2.setLayout(new java.awt.GridBagLayout());

        jPanel10.setLayout(new javax.swing.BoxLayout(jPanel10, javax.swing.BoxLayout.LINE_AXIS));

        jLabelSerialNumber.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        jLabelSerialNumber.setLabelFor(jTextFieldSN);
        jLabelSerialNumber.setText("Serial Number:");
        jLabelSerialNumber.setHorizontalTextPosition(javax.swing.SwingConstants.LEADING);
        jPanel10.add(jLabelSerialNumber);

        jPanel9.setMaximumSize(new java.awt.Dimension(5, 5));
        jPanel9.setMinimumSize(new java.awt.Dimension(5, 5));
        jPanel9.setPreferredSize(new java.awt.Dimension(5, 5));
        jPanel10.add(jPanel9);
        jPanel10.add(jTextFieldSN);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        jPanel2.add(jPanel10, gridBagConstraints);

        jPanel5.add(jPanel2);

        jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder("Type"));
        jPanel3.setLayout(new java.awt.GridBagLayout());

        jPanel6.setLayout(new javax.swing.BoxLayout(jPanel6, javax.swing.BoxLayout.LINE_AXIS));

        jLabelPartNumber.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        jLabelPartNumber.setLabelFor(jComboBoxPartNumber);
        jLabelPartNumber.setText("Part Number:");
        jLabelPartNumber.setHorizontalTextPosition(javax.swing.SwingConstants.LEADING);
        jPanel6.add(jLabelPartNumber);

        jPanel4.setMaximumSize(new java.awt.Dimension(5, 5));
        jPanel4.setMinimumSize(new java.awt.Dimension(5, 5));
        jPanel4.setPreferredSize(new java.awt.Dimension(5, 5));
        jPanel6.add(jPanel4);

        jPanel6.add(jComboBoxPartNumber);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 4, 6, 4);
        jPanel3.add(jPanel6, gridBagConstraints);

        jPanel7.setLayout(new javax.swing.BoxLayout(jPanel7, javax.swing.BoxLayout.LINE_AXIS));

        jLabelPartRev.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        jLabelPartRev.setLabelFor(jComboBoxPartRev);
        jLabelPartRev.setText("Part Revision:");
        jPanel7.add(jLabelPartRev);

        jPanel8.setMaximumSize(new java.awt.Dimension(5, 5));
        jPanel8.setMinimumSize(new java.awt.Dimension(5, 5));
        jPanel8.setPreferredSize(new java.awt.Dimension(5, 5));
        jPanel7.add(jPanel8);

        jPanel7.add(jComboBoxPartRev);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(6, 4, 6, 4);
        jPanel3.add(jPanel7, gridBagConstraints);

        jPanel11.setLayout(new javax.swing.BoxLayout(jPanel11, javax.swing.BoxLayout.LINE_AXIS));

        jLabelTestType.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        jLabelTestType.setLabelFor(jComboBoxTestType);
        jLabelTestType.setText("Test Type:");
        jPanel11.add(jLabelTestType);

        jPanel12.setMaximumSize(new java.awt.Dimension(5, 5));
        jPanel12.setMinimumSize(new java.awt.Dimension(5, 5));
        jPanel12.setPreferredSize(new java.awt.Dimension(5, 5));
        jPanel11.add(jPanel12);

        jPanel11.add(jComboBoxTestType);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(6, 4, 6, 4);
        jPanel3.add(jPanel11, gridBagConstraints);

        jPanel5.add(jPanel3);

        add(jPanel5, java.awt.BorderLayout.NORTH);

        jPanel1.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 25, 15));

        jButtonStart.setText("Start Sequence");
        jPanel1.add(jButtonStart);

        jButtonDebug.setText("Debug");
        jPanel1.add(jButtonDebug);

        jButtonCancel.setText("Cancel");
        jPanel1.add(jButtonCancel);

        add(jPanel1, java.awt.BorderLayout.SOUTH);
    }// </editor-fold>//GEN-END:initComponents

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonCancel;
    private javax.swing.JButton jButtonDebug;
    private javax.swing.JButton jButtonStart;
    private javax.swing.JComboBox jComboBoxPartNumber;
    private javax.swing.JComboBox jComboBoxPartRev;
    private javax.swing.JComboBox jComboBoxTestType;
    private javax.swing.JLabel jLabelPartNumber;
    private javax.swing.JLabel jLabelPartRev;
    private javax.swing.JLabel jLabelSerialNumber;
    private javax.swing.JLabel jLabelTestType;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel10;
    private javax.swing.JPanel jPanel11;
    private javax.swing.JPanel jPanel12;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JTextField jTextFieldSN;
    // End of variables declaration//GEN-END:variables
}
